<template>
    <div class='mx-6 sm:mx-14 text-xmas-gray'>
        <p class='text-4xl sm:text-5xl font-bold sm:text-center'>Доставка</p>
        <p class='text-sm mt-10 text-xmas-olive'>С кой куриер и как предпочиташ да получиш подаръка си?</p>
        <p class='text-sm mt-10 text-xmas-olive'>Можеш да го получиш в студиото на Шоуто или да го донесеш в последствие! Разбери още за #ГолямотоРазопаковане <a class='underline text-xmas-red cursor-pointer' @click="showUnboxingInfo">тук</a>!</p>
        <div class='mt-16 mb-10 space-y-10'>
            <Dropdown label='Куриер' :options="couriers" v-model="form.courier" @change="v$.form.courier.$touch()"></Dropdown>
            <Dropdown v-if='notForStudio' label='Вид доставка' :options="deliveryTypes" v-model="form.type" @change="v$.form.type.$touch()"></Dropdown>
        </div>
        <ButtonStack :disabled="v$.$invalid || v$.$pending" @click='advance'></ButtonStack>
    </div>
</template>

<script>
    import Dropdown from '@/components/Dropdown'
    import ButtonStack from '@/components/ButtonStack'
    import useVuelidate from '@vuelidate/core' 
    import { helpers, required, email, minLength, maxLength } from '@vuelidate/validators'
   
    export default {
        name: 'Step 4',
        components: {
            Dropdown,
            ButtonStack
        },
        data() {
            return {
                form: {
                    type: '',
                    courier: '',
                },           
                deliveryTypes: [
                    { id: 1, name: 'До офис' },
                    { id: 2, name: 'До адрес' },
                    
                ],
                couriers: [
                    { id: 1, name: 'Еконт' },
                    { id: 2, name: 'Спиди' },
                    { id: 3, name: 'В студиото на Шоуто' }
                ]
            }
        },
        methods: {  
            forward() {
                this.$store.commit('stepForward');
            },
            advance() {
                this.syncWithStore();
                this.$store.dispatch("register/advance")
            },
            syncWithStore() {
                this.$store.state.register.registrationData.type = this.form.type;
                this.$store.state.register.registrationData.courier = this.form.courier;
            },
            syncFromStore() {
                this.form.type = this.$store.state.register.registrationData.type;
                this.form.courier = this.$store.state.register.registrationData.courier;
            },
            showUnboxingInfo() {
                this.syncWithStore();
                this.$router.push({ name: 'unboxing' })
            }
        },
        computed: {
            notForStudio() {
                return this.form.courier.id != 3;
            }
        },
        watch: {
            'form.courier': function (value) {
                if (value.id === 3) {
                    this.form.type = 3;
                }
            }
        },
        mounted() {
            this.syncFromStore();
            
            if(! this.form.type)
                this.form.type = this.deliveryTypes[0];
            
            if(! this.form.courier)
                this.form.courier = this.couriers[0]
        },
        setup() {
            return { v$: useVuelidate() }
        },
        validations: {
            form: {
                courier: {
                    required,
                },
                type: {
                    required,
                }
            }
        }
    }
</script>